using System;
using System.Collections;

namespace EmitCode
{
    /// <summary>
    /// Summary description for EmitCache.
    /// </summary>
    public class EmitCache
    {
        internal class EmitCacheElem 
        {
            internal EmitCacheElem next;
            internal EmitCacheElem prev;
            internal String        expression;
            internal Object        emittedObject;

            internal void Link(EmitCacheElem elem) 
            {
                elem.prev = this;
                elem.next = next;
                next = next.prev = elem;
            }

            internal void Unlink() 
            {
                next.prev = prev;
                prev.next = next;
                next = prev = this;
            }

            internal EmitCacheElem() 
            {
                next = prev = this;
            }

            internal EmitCacheElem(String expression, Object emit, EmitCacheElem list) 
            {
                list.Link(this);
                this.expression = expression;
                this.emittedObject = emit;
            }
        }

        internal Object get(String expression) 
        {
            EmitCacheElem elem = (EmitCacheElem)hash[expression];
            if (elem != null) 
            { 
                elem.Unlink();
                lru.Link(elem);
                return elem.emittedObject;
            }
            return null;
        }

        internal void put(String expression, Object obj) 
        {
            hash[expression] = new EmitCacheElem(expression, obj, lru);
        }

        internal EmitCache(int emitCacheSize)
        {
            this.emitCacheSize = emitCacheSize;
            lru = new EmitCacheElem();
            hash = new Hashtable();
        }

        internal EmitCacheElem lru;
        internal Hashtable     hash;
        internal int           emitCacheSize;
    }
}
