using System;

namespace EmitCode
{
    /// <summary>
    /// Summary description for FilterGenerator.
    /// </summary>
    public class FilterGenerator
    {

        public Filter Generate(String condition) 
        {
            Filter filter = (Filter)cache.get(condition);
            if (filter == null) 
            {
                CodeGenerator cc = new CodeGenerator(elemType, typeof(ICondition), condition);
                filter = new Filter(elemType, (ICondition)cc.Generate());
                cache.put(condition, filter);
            } 
            return filter;
        }
        


        public FilterGenerator(Type elemType, int emitCacheSize)
        {
            this.elemType = elemType;
            cache = new EmitCache(emitCacheSize);
        }

        public FilterGenerator(Type elemType) : this(elemType, 100) {}

        private EmitCache cache;
        private Type      elemType;
    }
}
