using System;
using System.Collections;

namespace EmitCode
{
    /// <summary>
    /// Mapped colelction (collection produced by applying function to each element of original colelction)
    /// </summary>
    public class MappedCollection : IEnumerable
    {
        public Array ToArray()
        {
            ArrayList list = new ArrayList();
            foreach (Object elem in collection) 
            { 
                list.Add(expression.Evaluate(elem));
            }
            return list.ToArray(elemType);
        }

        private class MappedEnumerator : IEnumerator 
        {
            private IEnumerator enumerator;
            private IExpression expression;

            internal MappedEnumerator(ICollection collection, IExpression expression) 
            { 
                enumerator = collection.GetEnumerator();
                this.expression = expression;
            }

            public void Reset() 
            { 
                enumerator.Reset();
            }

            public bool MoveNext() 
            {
                return enumerator.MoveNext();
            }

            public Object Current 
            {
                get 
                {
                    return expression.Evaluate(enumerator.Current);
                }
            }
        }


        public IEnumerator GetEnumerator() 
        {
            return new MappedEnumerator(collection, expression);
        }

        internal MappedCollection(ICollection collection, Type elemType, IExpression expression)
        {
            this.collection = collection;
            this.elemType = elemType;
            this.expression = expression;
        }

        private ICollection collection;
        private Type        elemType;
        private IExpression expression;
    }
}
