using System;

namespace EmitCode
{
    /// <summary>
    /// Summary description for FilterGenerator.
    /// </summary>
    public class MapperGenerator
    {

        public Mapper Generate(String expression) 
        {
            Mapper mapper = (Mapper)cache.get(expression);
            if (mapper == null) 
            {
                CodeGenerator cc = new CodeGenerator(elemType, typeof(IExpression), expression);
                mapper = new Mapper(elemType, (IExpression)cc.Generate());
                cache.put(expression, mapper);
            } 
            return mapper;
        }
        


        public MapperGenerator(Type elemType, int emitCacheSize)
        {
            this.elemType = elemType;
            cache = new EmitCache(emitCacheSize);
        }

        public MapperGenerator(Type elemType) : this(elemType, 100) {}

        private EmitCache cache;
        private Type      elemType;
    }
}
